###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2010 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################

# keep around ready for later user
## global alphatag rc4

Name: rgmanager
Summary: Open Source HA Resource Group Failover for Red Hat Cluster
Version: 3.0.12
Release: 11%{?alphatag:.%{alphatag}}%{?dist}
License: GPLv2+ and LGPLv2+
Group: System Environment/Base
URL: http://sources.redhat.com/cluster/wiki/
Source0: https://fedorahosted.org/releases/c/l/cluster/%{name}-%{version}.tar.bz2

## patches

Patch1: pass_timeouts_to_resource_agents.patch
Patch2: use_sysrq_b_to_reboot.patch
Patch3: fix_staged_upgrade.patch
Patch4: rgmanager_init_lsb_compliant.patch
Patch5: make_clulog_filter_correctly.patch
Patch6: man_page_improvements.patch
Patch7: present_flags_in_clustat_output.patch
Patch8: fix_clustat_return_code.patch
Patch9: honor_restricted_fds_during_migrations.patch
Patch10: add_non_critical_flag_to_resources.patch
Patch11: add_non_critical_base_behavior.patch
Patch12: header_cleanup.patch
Patch13: use_rg_strings_c_for_flags.patch
Patch14: present_all_flags_in_clustat_output.patch
Patch15: mark_non_critical_resources_disabled.patch
Patch16: add_convalesce_operation.patch
Patch17: allow_restart,disable_recovery_policy.patch
Patch18: ensure_state_is_preserved_across_config_changes.patch
Patch19: fix_handling_of_independent_subtrees.patch
Patch20: do_not_fail_service_if_non_critical_resources_fail_to_stop.patch
Patch21: add_c_option_to_man_page_clusvcadm_h.patch
Patch22: add_independent_subtree_restart_thresholds.patch
Patch23: clean_up_independent_subtree_restart_handling.patch
Patch24: fix_corner_case_in_critical_non_critical_handling.patch
Patch25: support_convalesce_w_central_processing.patch
Patch26: update_last_owner_on_failover.patch
Patch27: dbus_notifications_for_service_state_changes.patch
Patch28: clean_up_dbus_notifications.patch
Patch29: retry_dbus_if_we_get_disconnected.patch
Patch30: minor_dbus_cleanups.patch
Patch31: match_fenced_s_option_to_disable_dbus.patch
Patch32: allow_dbus_notification_code_to_be_disabled.patch
Patch33: make_clufindhostname_i_predictable.patch
Patch34: fix_nofailback_when_service_is_in_starting_state.patch

## runtime

Requires: chkconfig initscripts 
Requires: cman resource-agents dbus
Requires(post): chkconfig
Requires(preun): initscripts
Requires(preun): chkconfig

## Setup/build bits

BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

# Build dependencies
BuildRequires: clusterlib-devel >= 3.0.0-1
BuildRequires: libxml2-devel ncurses-devel slang-devel dbus-devel

ExclusiveArch: i686 x86_64

%prep
%setup -q -n %{name}-%{version}

%patch1 -p1 -b .pass_timeouts_to_resource_agents
%patch2 -p1 -b .use_sysrq_b_to_reboot
%patch3 -p1 -b .fix_staged_upgrade
%patch4 -p1 -b .rgmanager_init_lsb_compliant
%patch5 -p1 -b .make_clulog_filter_correctly
%patch6 -p1 -b .man_page_improvements
%patch7 -p1 -b .present_flags_in_clustat_output
%patch8 -p1 -b .fix_clustat_return_code
%patch9 -p1 -b .honor_restricted_fds_during_migrations
%patch10 -p1 -b .add_non_critical_flag_to_resources
%patch11 -p1 -b .add_non_critical_base_behavior
%patch12 -p1 -b .header_cleanup
%patch13 -p1 -b .use_rg_strings_c_for_flags
%patch14 -p1 -b .present_all_flags_in_clustat_output
%patch15 -p1 -b .mark_non_critical_resources_disabled
%patch16 -p1 -b .add_convalesce_operation
%patch17 -p1 -b .allow_restart,disable_recovery_policy
%patch18 -p1 -b .ensure_state_is_preserved_across_config_changes
%patch19 -p1 -b .fix_handling_of_independent_subtrees
%patch20 -p1 -b .do_not_fail_service_if_non_critical_resources_fail_to_stop
%patch21 -p1 -b .add_c_option_to_man_page_clusvcadm_h
%patch22 -p1 -b .add_independent_subtree_restart_thresholds
%patch23 -p1 -b .clean_up_independent_subtree_restart_handling
%patch24 -p1 -b .fix_corner_case_in_critical_non_critical_handling
%patch25 -p1 -b .support_convalesce_w_central_processing
%patch26 -p1 -b .update_last_owner_on_failover
%patch27 -p1 -b .dbus_notifications_for_service_state_changes
%patch28 -p1 -b .clean_up_dbus_notifications
%patch29 -p1 -b .retry_dbus_if_we_get_disconnected
%patch30 -p1 -b .minor_dbus_cleanups
%patch31 -p1 -b .match_fenced_s_option_to_disable_dbus
%patch32 -p1 -b .allow_dbus_notification_code_to_be_disabled
%patch33 -p1 -b .make_clufindhostname_i_predictable
%patch34 -p1 -b .fix_nofailback_when_service_is_in_starting_state

%build
./configure \
  --sbindir=%{_sbindir} \
  --initddir=%{_sysconfdir}/rc.d/init.d \
  --libdir=%{_libdir} \
  --without_fence_agents \
  --without_resource_agents \
  --without_kernel_modules \
  --disable_kernel_check

##CFLAGS="$(echo '%{optflags}')" make %{_smp_mflags}
CFLAGS="$(echo '%{optflags}')" make -C rgmanager all

%install
rm -rf %{buildroot}
make -C rgmanager install DESTDIR=%{buildroot}

%clean
rm -rf %{buildroot}

%description
Red Hat Resource Group Manager provides high availability of critical server
applications in the event of planned or unplanned system downtime.

%post
/sbin/chkconfig --add rgmanager

%preun
if [ "$1" = 0 ]; then
	/sbin/service rgmanager stop >/dev/null 2>&1
	/sbin/chkconfig --del rgmanager
fi

%files
%defattr(-,root,root,-)
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence rgmanager/README rgmanager/errors.txt
%{_sysconfdir}/rc.d/init.d/rgmanager
%{_sbindir}/clu*
%{_sbindir}/rgmanager
%{_sbindir}/rg_test
%{_mandir}/man8/clu*
%{_mandir}/man8/rgmanager*

%changelog
* Thu Feb 03 2011 Lon Hohberger <lhh@redhat.com> - 3.0.12-11
- rgmanager: Present flags in clustat output
  (present_flags_in_clustat_output.patch)
  Resolves: rhbz#634298
- rgmanager: Fix clustat return code
  (fix_clustat_return_code.patch)
  Resolves: rhbz#621562
- rgmanager: Honor restricted FDs during migrations
  (honor_restricted_fds_during_migrations.patch)
  Resolves: rhbz#621694
- rgmanager: Add non-critical flag to resources
  (add_non_critical_flag_to_resources.patch)
  rgmanager: Add non-critical base behavior
  (add_non_critical_base_behavior.patch)
  rgmanager: Header cleanup
  (header_cleanup.patch)
  rgmanager: Use rg_strings.c for flags
  (use_rg_strings_c_for_flags.patch)
  rgmanager: Present all flags in clustat output
  (present_all_flags_in_clustat_output.patch)
  rgmanager: Mark non-critical resources disabled
  (mark_non_critical_resources_disabled.patch)
  rgmanager: Add convalesce operation
  (add_convalesce_operation.patch)
  rgmanager: Allow restart,disable recovery policy
  (allow_restart,disable_recovery_policy.patch)
  rgmanager: Ensure state is preserved across config changes
  (ensure_state_is_preserved_across_config_changes.patch)
  rgmanager: Fix handling of independent subtrees
  (fix_handling_of_independent_subtrees.patch)
  rgmanager: Do not fail service if non-critical resources fail to stop
  (do_not_fail_service_if_non_critical_resources_fail_to_stop.patch)
  rgmanager: Add -c option to man page & clusvcadm -h
  (add_c_option_to_man_page_clusvcadm_h.patch)
  rgmanager: Add independent subtree restart thresholds
  (add_independent_subtree_restart_thresholds.patch)
  rgmanager: clean up independent subtree restart handling
  (clean_up_independent_subtree_restart_handling.patch)
  rgmanager: Fix corner case in critical/non-critical handling
  (fix_corner_case_in_critical_non_critical_handling.patch)
  rgmanager: Support convalesce w/ central_processing
  (support_convalesce_w_central_processing.patch)
  Resolves: rhbz#634277
- rgmanager: Update last_owner on failover
  (update_last_owner_on_failover.patch)
  Resolves: rhbz#639103
- rgmanager: DBus notifications for service state changes
  (dbus_notifications_for_service_state_changes.patch)
  rgmanager: Clean up dbus notifications
  (clean_up_dbus_notifications.patch)
  rgmanager: Retry dbus if we get disconnected
  (retry_dbus_if_we_get_disconnected.patch)
  rgmanager: minor dbus cleanups
  (minor_dbus_cleanups.patch)
  rgmanager: Match fenced's option to disable DBus
  (match_fenced_s_option_to_disable_dbus.patch)
  rgmanager: allow dbus notification code to be disabled
  (allow_dbus_notification_code_to_be_disabled.patch)
  Resolves: rhbz#657756
- rgmanager: Make clufindhostname -i predictable
  (make_clufindhostname_i_predictable.patch)
  Resolves: rhbz#661881
- rgmanager: Fix nofailback when service is in 'starting' state
  (fix_nofailback_when_service_is_in_starting_state.patch)
  Resolves: rhbz#672841

* Mon Jul 12 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-10
- Add failover domain documentation and other improvements
  (man_page_improvements.patch)
  Resolves: rhbz#557563

* Mon Jul 12 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-9
- Make clulog filter correctly based on cluster.conf
  (make_clulog_filter_correctly.patch)
  Resolves: rhbz#609866

* Mon Jul 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12-8
- Fix patch file naming
  Related: rhbz#612110

* Fri Jul  9 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12-7
- Fix rgmanager init script to be more LSB compliant
  (rgmanager_init_lsb_compliant.patch)
  Resolves: rhbz#612110

* Wed Jun 30 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-6
- Fix staged upgrade
  (fix_staged_upgrade.patch)
  Resolves: rhbz#609550

* Wed Jun 30 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-5
- Fix 3.0.12-3 changelog

* Tue Jun 29 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-3
- Use sysrq-b to reboot
  (use_sysrq_b_to_reboot.patch)
  Resolves: rhbz#609181

* Fri Jun 25 2010 Lon Hohberger <lhh@redhat.com> - 3.0.12-2
- Pass timeouts to resource agents
  (pass_timeouts_to_resource_agents.patch)
  Resolves: rhbz#606480

* Wed May 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.12-1
- Rebase on top of new upstream bug fix only release:
  * drop all bug fix patches.
  * Addresses the follwing issues from 3.0.12 release:
  Resolves: rhbz#588890, rhbz#588925, rhbz#589131, rhbz#588010
  * Rebase:
  Resolves: rhbz#582350
- Stop build on ppc and ppc64.
  Resolves: rhbz#591000

* Wed Apr  7 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.9-2
- Fix 2+ simultaneous relocation crash
  (fix_2_or_more_simultaneous_relocation_crash.patch)
  Resolves: rhbz#577856
- Fix meory leaks during relocation
  (fix_memory_leaks_during_relocation.patch)
  (fix_memory_leak_during_reconfig.patch)
  Resolves: rhbz#578249

* Tue Mar  2 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.9-1
- New upstream release
  Resolves: rhbz#569956, rhbz#569953
- spec file update:
  * update spec file copyright date
  * use bz2 tarball

* Thu Feb 25 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.7-2
- Resolves: rhbz#568011
- Do not build rgmanager on s390 and s390x.

* Tue Jan 12 2010 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.7-1
- New upstream release

* Mon Dec  7 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.6-1
- New upstream release
- spec file cleanup:
  * use global instead of define
  * use new Source0 url
  * use %name macro more aggressively

* Fri Nov 20 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.5-1
- New upstream release

* Wed Oct 21 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.4-1
- New upstream release

* Tue Sep  1 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.3-1
- Split from cluster srpm
